﻿XIncludeFile("PB64__DECLARE.pbi")

Procedure.s RelativePath(startDir.s ,  targetDir.s , backSlash.s = "\")
	Protected p1.s,p2.s,p3.s,l
	
	p1 = GetPathPart(startDir) : If Right(p1,1) <> backSlash : p1 + backSlash : EndIf
	p2 = GetPathPart(targetDir) : If Right(p2,1) <> backSlash : p2 + backSlash : EndIf
	
	If Len(p1) < Len(p2)
		ProcedureReturn ReplaceString(p2 , p1 , "") + GetFilePart(targetDir)
	Else
		Repeat
			l + 1
		Until (l > Len(p2)) Or (UCase(Mid(p1,l,1)) <> UCase(Mid(p2,l,1)))
		If l = 1 : ProcedureReturn targetDir : EndIf
 		p3 = Mid(p1,l)
		p1 = ReplaceString(p2,Left(p1,l-1),"")
		p2 = ""
		For l = 1 To CountString(p3 , backSlash)
			p2 + ".." + backSlash
		Next
		ProcedureReturn p2 + p1 + GetFilePart(targetDir)
	EndIf
EndProcedure

Procedure IO_Init()
	ClearStructure(@IO, S_IO)
	InitializeStructure(@IO, S_IO)
	
	Protected i
	For i = 0 To 8
		IO\Keyboard_Matrix[i] = $FF
	Next
	
	Restore Keymatrix
	For i = 0 To 63
		Protected matrix.a, ascii.a, shifted.a
		
		Read.a matrix
		Read.a ascii
		Read.a shifted
		
		IO\AsciiToKeymatrix(Hex(ascii))				= $0000 | matrix
		IO\AsciiToKeymatrix(Hex(shifted))			= $1700 | matrix
		IO\KeymatrixToAscii(Hex($0000 | matrix))	= ascii
		IO\KeymatrixToAscii(Hex($1700 | matrix))	= shifted
	Next
	
	IO\Color_Palette[$3]				= RGB($00, $00, $00); black
	IO\Color_Palette[$1]				= RGB($ff, $ff, $ff); white
	IO\Color_Palette[$2]				= RGB($ab, $31, $26); red
	IO\Color_Palette[$3]				= RGB($66, $da, $ff); light blue
	IO\Color_Palette[$4]				= RGB($bb, $3f, $b8); purple
	IO\Color_Palette[$5]				= RGB($55, $ce, $58); green
	IO\Color_Palette[$6]				= RGB($1d, $0e, $97); dark blue
	IO\Color_Palette[$7]				= RGB($ea, $f5, $7c); yellow
	IO\Color_Palette[$8]				= RGB($b9, $74, $18); brown
	IO\Color_Palette[$9]				= RGB($78, $53, $00); dark brown
	IO\Color_Palette[$A]				= RGB($dd, $93, $87); light red
	IO\Color_Palette[$B]				= RGB($5b, $5b, $5b); dark grey
	IO\Color_Palette[$C]				= RGB($8b, $8b, $8b); mid grey
	IO\Color_Palette[$D]				= RGB($b0, $f4, $ac); light green
	IO\Color_Palette[$E]				= RGB($aa, $9d, $ef); mid blue
	IO\Color_Palette[$F]				= RGB($b8, $b8, $b8); light grey
	
	; keymap letters
	IO\keymap(Str(#PB_Key_Back))		= $00 ; del
	IO\keymap(Str(#PB_Key_Return))		= $01
	IO\keymap(Str(#PB_Key_Left))		= $02 	
	IO\keymap(Str(#PB_Key_Right))		= $02
	IO\keymap(Str(#PB_Key_F7))			= $03	
	IO\keymap(Str(#PB_Key_F1))			= $04
	IO\keymap(Str(#PB_Key_F3))			= $05
	IO\keymap(Str(#PB_Key_F5))			= $06
	IO\keymap(Str(#PB_Key_Up))			= $07
	IO\keymap(Str(#PB_Key_Down))		= $07
	
	IO\keymap(Str(#PB_Key_3))			= $10
	IO\keymap(Str(#PB_Key_W))			= $11
	IO\keymap(Str(#PB_Key_A))			= $12
	IO\keymap(Str(#PB_Key_4))			= $13
	IO\keymap(Str(#PB_Key_Z))			= $14
	IO\keymap(Str(#PB_Key_S))			= $15
	IO\keymap(Str(#PB_Key_E))			= $16
	IO\keymap(Str(#PB_Key_LeftShift))	= $17
	
	IO\keymap(Str(#PB_Key_5))			= $20
	IO\keymap(Str(#PB_Key_R))			= $21
	IO\keymap(Str(#PB_Key_D))			= $22
	IO\keymap(Str(#PB_Key_6))			= $23
	IO\keymap(Str(#PB_Key_C))			= $24
	IO\keymap(Str(#PB_Key_F))			= $25
	IO\keymap(Str(#PB_Key_T))			= $26
	IO\keymap(Str(#PB_Key_X))			= $27
	
	IO\keymap(Str(#PB_Key_7))			= $30
	IO\keymap(Str(#PB_Key_Y))			= $31
	IO\keymap(Str(#PB_Key_G))			= $32
	IO\keymap(Str(#PB_Key_8))			= $33
	IO\keymap(Str(#PB_Key_B))			= $34
	IO\keymap(Str(#PB_Key_H))			= $35
	IO\keymap(Str(#PB_Key_U))			= $36
	IO\keymap(Str(#PB_Key_V))			= $37
	
	IO\keymap(Str(#PB_Key_9))			= $40
	IO\keymap(Str(#PB_Key_I))			= $41
	IO\keymap(Str(#PB_Key_J))			= $42
	IO\keymap(Str(#PB_Key_0))			= $43
	IO\keymap(Str(#PB_Key_M))			= $44
	IO\keymap(Str(#PB_Key_K))			= $45
	IO\keymap(Str(#PB_Key_O))			= $46
	IO\keymap(Str(#PB_Key_N))			= $47
	
	IO\keymap(Str(#PB_Key_Add))			= $50
	IO\keymap(Str(#PB_Key_P))			= $51
	IO\keymap(Str(#PB_Key_L))			= $52
 	IO\keymap(Str(#PB_Key_Subtract))	= $53
 	IO\keymap(Str(#PB_Key_Period))		= $54 ; .
 	IO\keymap(Str(53))					= $55 ; :
  	IO\keymap(Str(#PB_Key_Apostrophe))	= $56 ; @
  	IO\keymap(Str(#PB_Key_Comma))		= $57
  	
   	IO\keymap(Str(#PB_Key_LeftBracket))	= $60 ; £
 	IO\keymap(Str(#PB_Key_Multiply))	= $61
 	IO\keymap(Str(#PB_Key_SemiColon))	= $62
 	IO\keymap(Str(#PB_Key_Home))		= $63 ; CLR/HOME
 	IO\keymap(Str(#PB_Key_RightShift))	= $64
 	IO\keymap(Str(#PB_Key_Equals))		= $65
 	IO\keymap(Str(#PB_Key_PageUp))		= $66
 	IO\keymap(Str(12))					= $67 ; /
  	
  	IO\keymap(Str(#PB_Key_1))			= $70
  	IO\keymap(Str(#PB_Key_Grave))		= $71 ; <-
  	IO\keymap(Str(#PB_Key_End))			= $72 ; CTRL
	IO\keymap(Str(#PB_Key_2))			= $73
	IO\keymap(Str(#PB_Key_Space))		= $74
	IO\keymap(Str(128))					= $75 ; commodore key
	IO\keymap(Str(#PB_Key_Q))			= $76
 	IO\keymap(Str(#PB_Key_Escape))		= $77 ; break  	
  	
 	IO\kWait							= 18000
 	IO\lastFrameTime					= ElapsedMilliseconds()
 	IO\retval							= #True
 	IO\Joystick[0]						= %00000
 	IO\Joystick[1]						= %00000
 	IO\InputMode						= 0
 	
 	DataSection
 		Keymatrix:
 		Data.a $00, '_', '_', $01,  10, '_', $02, '_', '_', $03, '_', '_', $04, '_', '_', $05, '_', '_', $06, '_', '_', $07, '_', '_'
 		Data.a $10, '3', '#', $11, 'W', '_', $12, 'A', '_', $13, '4', '$', $14, 'Z', '_', $15, 'S', '_', $16, 'E', '_', $17, '_', '_'
 		Data.a $20, '5', '%', $21, 'R', '_', $22, 'D', '_', $23, '6', '&', $24, 'C', '_', $25, 'F', '_', $26, 'T', '_', $27, 'X', '_'
 		Data.a $30, '7',  39, $31, 'Y', '_', $32, 'G', '_', $33, '8', '(', $34, 'B', '_', $35, 'H', '_', $36, 'U', '_', $37, 'V', '_'
 		Data.a $40, '9', ')', $41, 'I', '_', $42, 'J', '_', $43, '0', '_', $44, 'M', '_', $45, 'K', '_', $46, 'O', '_', $47, 'N', '_'
 		Data.a $50, '+', '_', $51, 'P', '_', $52, 'L', '_', $53, '-', '_', $54, '.', '>', $55, ':', '[', $56, '@', '_', $57, ',', '<'
 		Data.a $60, '£', '_', $61, '*', '_', $62, ';', ']', $63, '_', '_', $64, '_', '_', $65, '=', '_', $66, '_', '_', $67, '/', '?'
 		Data.a $70, '1', '!', $71, '_', '_', $72, '_', '_', $73, '2', 34,  $74, ' ', '_', $75, '_', '_', $76, 'Q', '_', $77, '_', '_'
 	EndDataSection
EndProcedure

Procedure IO_Type(v.u)
	LastElement(IO\KeyboardBuffer())
	If (v & $FF00)
		; shift down
		AddElement(IO\KeyboardBuffer()):	IO\KeyboardBuffer() = 1
		AddElement(IO\KeyboardBuffer()):	IO\KeyboardBuffer() = $17
	EndIf
	AddElement(IO\KeyboardBuffer()):	IO\KeyboardBuffer() = 1
	AddElement(IO\KeyboardBuffer()):	IO\KeyboardBuffer() = v & $FF
	AddElement(IO\KeyboardBuffer()):	IO\KeyboardBuffer() = 0
	AddElement(IO\KeyboardBuffer()):	IO\KeyboardBuffer() = v & $FF
	If (v & $FF00)
		; shift up
		AddElement(IO\KeyboardBuffer()):	IO\KeyboardBuffer() = 0
		AddElement(IO\KeyboardBuffer()):	IO\KeyboardBuffer() = $17
	EndIf
EndProcedure

Procedure IO_LoadPRG(path.s, startPrg = #False)
	Protected file = ReadFile(#PB_Any, path)
	If IsFile(file)
		; 		C64_Reset()
		Protected ofs.u = ReadWord(file)
		Protected pbuf.u = ofs
		
		pbuf + ReadData(file, @MEMORY\RAM[ofs], Lof(file) - 2)
		CloseFile(file)
		
		C64\pathPrg		= path
		C64\pathState	= "state\" + GetFilePart(C64\pathPrg, #PB_FileSystem_NoExtension) + ".bin"
		
		If startPrg
			If (ofs = #AddressBasicArea)
				MEMORY_WriteWordNoIo(#AddressBasicText, #AddressBasicArea)
				MEMORY_WriteWordNoIo(#AddressBasicVars, pbuf)
				MEMORY_WriteWordNoIo(#AddressBasicArray, pbuf)
				MEMORY_WriteWordNoIo(#AddressBasicArrayEnd, pbuf)
				
				IO_Init()
				
				; exec RUN
				IO_Type($21); R
				IO_Type($36); U
				IO_Type($47); N
				IO_Type($01); Return
			Else
				CPU\PC = ofs
			EndIf
		EndIf
		
		StatusBarText(#StatusBar, 0, GetFilePart(path) + " loaded (" + Hex(ofs) + " - " + Hex(pbuf) + ")")
		
	EndIf
	
	ProcedureReturn file
EndProcedure

Procedure IO_SaveState(path.s)
	Protected file = CreateFile(#PB_Any, path)
	Protected result
	
	If IsFile(file)
		C64\pathState = path
		
		result + WriteData(file, *CIA1, SizeOf(S_CIA))
		result + WriteData(file, *CIA2, SizeOf(S_CIA))
		result + WriteData(file, @CPU, SizeOf(S_CPU))
		result + WriteData(file, @VIC, SizeOf(S_VIC))
 		result + WriteData(file, @SID, SizeOf(S_SID))
		result + WriteData(file, @MEMORY, SizeOf(S_MEMORY))		
		CloseFile(file)
	EndIf
	
	ProcedureReturn result
EndProcedure

Procedure IO_LoadState(path.s)
	Protected file = ReadFile(#PB_Any, path)
	Protected result
	
	If IsFile(file)
		C64\pathState = path		
		
		IO_Init()
		
		result + ReadData(file, *CIA1, SizeOf(S_CIA))
		result + ReadData(file, *CIA2, SizeOf(S_CIA))
		result + ReadData(file, @CPU, SizeOf(S_CPU))
		result + ReadData(file, @VIC, SizeOf(S_VIC))
 		result + ReadData(file, @SID, SizeOf(S_SID))
		result + ReadData(file, @MEMORY, SizeOf(S_MEMORY))		
		CloseFile(file)
	EndIf
	
	ProcedureReturn result
EndProcedure

Procedure IO_Handle_JoystickDown(port, mask.a)		
	IO\InputMode = port
	IO\Joystick[port] | mask
EndProcedure

Procedure IO_Handle_JoystickUp(port, mask.a)
	IO\InputMode = port
	IO\Joystick[port] & ~mask
EndProcedure

Procedure IO_Handle_KeyDown(pair)
	IO\InputMode = #C64_KeyBrd
	Protected mask.a = ~(1 << (pair & $F))
	IO\Keyboard_Matrix[(pair >> 4)] & mask
EndProcedure

Procedure IO_Handle_KeyUp(pair)
	IO\InputMode = #C64_KeyBrd
	Protected mask.a = (1 << (pair & $F))
	IO\Keyboard_Matrix[(pair >> 4)] | mask
EndProcedure

Procedure IO_PressKey(key)
	If FindMapElement(IO\keymap(), Str(key))
		IO_Handle_KeyDown(IO\keymap())
	EndIf
EndProcedure

Procedure IO_ReleaseKey(key)
	If FindMapElement(IO\keymap(), Str(key))
		IO_Handle_KeyUp(IO\keymap())
	EndIf
EndProcedure

Procedure IO_PasteClipboard()
	Protected text.s = GetClipboardText()
	Protected n
	
	For n = 1 To Len(text)
		Protected ascii.a = Asc(UCase(Mid(text, n, 1)))
 		If FindMapElement(IO\AsciiToKeymatrix(), Hex(ascii))
 			IO_Type(IO\AsciiToKeymatrix())
		EndIf
	Next
EndProcedure

Procedure IO_ConfigJoystickKey(joystickState, message.s)
	Protected joystickKey = 0
	
	StatusBarText(#StatusBar, 0, message)
	
	Repeat
		ExamineKeyboard()
		
		Protected key
		For key = 1 To 255
			If KeyboardPushed(key)
				joystickKey = key
				Break
			EndIf
		Next
		
		Select WaitWindowEvent(250)
			Case #PB_Event_CloseWindow
				C64\State | #C64_State_Quit
				ProcedureReturn
		EndSelect
	Until joystickKey <> 0
	
	C64\JoystickKey[joystickState] = joystickKey
	
	If OpenPreferences(PreferenceFile)
		PreferenceGroup("JoystickKeys")
		WritePreferenceInteger("JoystickUp",	C64\JoystickKey[#C64_Joystick_Up])
		WritePreferenceInteger("JoystickDown",	C64\JoystickKey[#C64_Joystick_Down])
		WritePreferenceInteger("JoystickLeft",	C64\JoystickKey[#C64_Joystick_Left])
		WritePreferenceInteger("JoystickRight",	C64\JoystickKey[#C64_Joystick_Right])
		WritePreferenceInteger("JoystickFire",	C64\JoystickKey[#C64_Joystick_Fire])
		ClosePreferences()		
	EndIf
EndProcedure

Procedure IO_ExamineKeyvoard()
	ExamineKeyboard()
	
	Protected key
	For key = 1 To 255
		If (IO\KeyDown(key) = 0) And KeyboardPushed(key)
			IO\KeyDown(key) = 1
			Select key
				Case #PB_Key_Escape							: ClearList(IO\KeyboardBuffer()) : C64\vSyncEnabled = GetMenuItemState(#Menu_0, #m_Vsync)
				Case #PB_Key_Tab: 							: CPU_NMI(); RESTORE
				Case C64\JoystickKey[#C64_Joystick_Up]		: IO_Handle_JoystickDown(C64\JoystickPort, #IO_JoystickMask_Up)		: Break
				Case C64\JoystickKey[#C64_Joystick_Down]	: IO_Handle_JoystickDown(C64\JoystickPort, #IO_JoystickMask_Down)	: Break
				Case C64\JoystickKey[#C64_Joystick_Left]	: IO_Handle_JoystickDown(C64\JoystickPort, #IO_JoystickMask_Left)	: Break
				Case C64\JoystickKey[#C64_Joystick_Right]	: IO_Handle_JoystickDown(C64\JoystickPort, #IO_JoystickMask_Right)	: Break
				Case C64\JoystickKey[#C64_Joystick_Fire]	: IO_Handle_JoystickDown(C64\JoystickPort, #IO_JoystickMask_Fire)	: Break
				Case #PB_Key_Up, #PB_Key_Left				: IO_PressKey(#PB_Key_LeftShift)
			EndSelect
			IO_PressKey(key)
		ElseIf IO\KeyDown(key) And KeyboardReleased(key)
			IO\KeyDown(key) = 0
			Select key
				Case C64\JoystickKey[#C64_Joystick_Up]		: IO_Handle_JoystickUp(C64\JoystickPort, #IO_JoystickMask_Up)		: Break
				Case C64\JoystickKey[#C64_Joystick_Down]	: IO_Handle_JoystickUp(C64\JoystickPort, #IO_JoystickMask_Down)		: Break
				Case C64\JoystickKey[#C64_Joystick_Left]	: IO_Handle_JoystickUp(C64\JoystickPort, #IO_JoystickMask_Left)		: Break
				Case C64\JoystickKey[#C64_Joystick_Right]	: IO_Handle_JoystickUp(C64\JoystickPort, #IO_JoystickMask_Right)	: Break
				Case C64\JoystickKey[#C64_Joystick_Fire]	: IO_Handle_JoystickUp(C64\JoystickPort, #IO_JoystickMask_Fire)		: Break
				Case #PB_Key_Up, #PB_Key_Left				: IO_ReleaseKey(#PB_Key_LeftShift)
			EndSelect
			IO_ReleaseKey(key)
		EndIf
	Next
EndProcedure


Procedure IO_ProcessEvents()
	IO_ExamineKeyvoard()
		
	While WindowEvent()
		Select Event()
			Case #PB_Event_CloseWindow
				C64\State | #C64_State_Quit
			Case #PB_Event_SizeWindow
				Protected factor.d = #VisibleScreenHeight / #VisibleScreenWidth
				If WindowWidth(#MainWindow) > WindowHeight(#MainWindow)
					ResizeWindow(#MainWindow, #PB_Ignore, #PB_Ignore, #PB_Ignore, WindowWidth(#MainWindow) * factor)
				Else
					ResizeWindow(#MainWindow, #PB_Ignore, #PB_Ignore, #PB_Ignore, WindowHeight(#MainWindow) * factor)
				EndIf
			Case #PB_Event_Menu
				Select EventMenu()
					Case #m_Quit
						C64\State | #C64_State_Quit
					Case #m_PasteClip
						IO_PasteClipboard()	
					Case #m_SaveState
						If IO_SaveState(SaveFileRequester("Save state", C64\pathState, "*.bin|*.bin", 0))
							StatusBarText(#StatusBar, 0, "State saved")
						EndIf
					Case #m_LoadState
						If IO_LoadState(OpenFileRequester("Load state", C64\pathState, "*.bin|*.bin", 0))
							StatusBarText(#StatusBar, 0, "State loaded")
						EndIf
					Case #m_QuickLoadFirst To #m_QuickLoadLast
						If OpenPreferences(PreferenceFile)
							PreferenceGroup("Quickload")
							Protected i = EventMenu() - #m_QuickLoadFirst
							Protected recent.s = RelativePath(GetPathPart(ProgramFilename()), ReadPreferenceString("Recent" +Str(i), ""))
							If IO_LoadPRG(recent, GetMenuItemState(#Menu_0, #m_AutoRun))
								For i = EventMenu() To #m_QuickLoadFirst + 1 Step - 1
									WritePreferenceString("Recent" +Str(i), ReadPreferenceString("Recent" +Str(i - 1), ""))
								Next
								WritePreferenceString("Recent0", recent)
								
								For i = #m_QuickLoadFirst To #m_QuickLoadLast
									SetMenuItemText(#Menu_0, i, ReadPreferenceString("Recent" + Str(i), "-"))
								Next
							EndIf
							ClosePreferences()
						EndIf
					Case #m_Open
						Protected file.s = OpenFileRequester("", "", "*.prg|*.prg", 1)
						Protected addIndex = #True
						If IO_LoadPRG(file, GetMenuItemState(#Menu_0, #m_AutoRun))
							file = RelativePath(ProgramPath, file)

							If OpenPreferences(PreferenceFile) = 0
								CreatePreferences(PreferenceFile)
							EndIf
							
							; update recent files
							If OpenPreferences(PreferenceFile)
								PreferenceGroup("Quickload")
								
								For i = #m_QuickLoadFirst To #m_QuickLoadLast
									If ReadPreferenceString("Recent" + i, "") = file
										addIndex = #False
									EndIf								
								Next
								If addIndex
									For i = #m_QuickLoadLast To #m_QuickLoadFirst + 1 Step -1
										Recent = ReadPreferenceString("Recent" + Str(i - 1), "")
										If Recent
											WritePreferenceString("Recent" + Str(i), Recent)
										EndIf								
									Next
									WritePreferenceString("Recent0", file)
									
									For i = #m_QuickLoadFirst To #m_QuickLoadLast
										SetMenuItemText(#Menu_0, i, GetFilePart(ReadPreferenceString("Recent" + Str(i), "-")))
									Next
								EndIf
								ClosePreferences()
							EndIf
						EndIf
					Case #m_AutoRun
						If GetMenuItemState(#Menu_0, #m_AutoRun) = 1
							SetMenuItemState(#Menu_0, #m_AutoRun, 0)
						Else
							SetMenuItemState(#Menu_0, #m_AutoRun, 1)
						EndIf
					Case #m_Joystickport1
						SetMenuItemState(#Menu_0, #m_Joystickport1, 1)
						SetMenuItemState(#Menu_0, #m_Joystickport2, 0)
						C64\JoystickPort = #C64_Joystick_Port1
					Case #m_Joystickport2
						SetMenuItemState(#Menu_0, #m_Joystickport1, 0)
						SetMenuItemState(#Menu_0, #m_Joystickport2, 1)
						C64\JoystickPort = #C64_Joystick_Port2
					Case #m_JoystickKeys
						If GetMenuItemState(#Menu_0, #m_JoystickKeys) = 1
							SetMenuItemState(#Menu_0, #m_JoystickKeys, 0)
						Else
							SetMenuItemState(#Menu_0, #m_JoystickKeys, 1)
						EndIf
					Case #m_JoystickConfigUp:		IO_ConfigJoystickKey(#C64_Joystick_Up, "Press Key: Up")
					Case #m_JoystickConfigDown:		IO_ConfigJoystickKey(#C64_Joystick_Down, "Press Key: Down")
					Case #m_JoystickConfigLeft:		IO_ConfigJoystickKey(#C64_Joystick_Left, "Press Key: Left")
					Case #m_JoystickConfigRight:	IO_ConfigJoystickKey(#C64_Joystick_Right, "Press Key: Right")
					Case #m_JoystickConfigFire:		IO_ConfigJoystickKey(#C64_Joystick_Fire, "Press Key: Fire")
					Case #m_Vsync
						If GetMenuItemState(#Menu_0, #m_Vsync) = 1
							SetMenuItemState(#Menu_0, #m_Vsync, 0)
							C64\vSyncEnabled = #False
						Else
							SetMenuItemState(#Menu_0, #m_Vsync, 1)
							C64\vSyncEnabled = #True
						EndIf
					Case #m_Sound
						If GetMenuItemState(#Menu_0, #m_Sound) = 1
							SetMenuItemState(#Menu_0, #m_Sound, 0)
							C64\SoundEnabled = #False
							SDL_PauseAudio(1)
						Else
							SetMenuItemState(#Menu_0, #m_Sound, 1)
							C64\SoundEnabled = #True
							SDL_PauseAudio(0)
						EndIf
					Case #m_Reset
						C64_Reset()
				EndSelect
		EndSelect
	Wend
	
	If FirstElement(IO\KeyboardBuffer())
		C64\vSyncEnabled = #False
		If CPU\Cycles > IO\next_key_event_at
			Protected keyState =IO\KeyboardBuffer()
			DeleteElement(IO\KeyboardBuffer())
			
			If FirstElement(IO\KeyboardBuffer())
				If keyState = 1
					IO_Handle_KeyDown(IO\KeyboardBuffer())
				Else
					IO_Handle_KeyUp(IO\KeyboardBuffer())
				EndIf
				DeleteElement(IO\KeyboardBuffer())
			EndIf
		EndIf
		IO\next_key_event_at = CPU\Cycles + 1000;IO\kWait
		
		If ListSize(IO\KeyboardBuffer()) = 0
			C64\vSyncEnabled = GetMenuItemState(#Menu_0, #m_Vsync)
		EndIf
	EndIf
EndProcedure

Procedure IO_DrawLine(x, y, n, color)
	Protected o = y * #ScreenWidth  + x
	Protected c = IO\Color_Palette[(color) & $F]
	
	FillMemory(@IO\Frame[o], n * SizeOf(Long), c, #PB_Long)
EndProcedure

Procedure IO_VSync()
	If C64\vSyncEnabled
		Protected t = (ElapsedMilliseconds() - IO\lastFrameTime)
		
		If (t < #RefreshRate)
	 		Delay(#RefreshRate - t)
	 	EndIf
		
		IO\lastFrameTime = ElapsedMilliseconds()
	EndIf
EndProcedure

Procedure IO_RefreshScreen()
	Protected row, col, ofs
	
	Static fps, fpsTime
	
	fps + 1
	If ElapsedMilliseconds() > fpsTime
		StatusBarText(#StatusBar, 1, "fps: " + Str(fps), #PB_StatusBar_Center)
		fps = 0
		fpsTime = ElapsedMilliseconds() + 1000
	EndIf
	
	If StartDrawing(ScreenOutput())
		For row = 0 To #VisibleScreenHeight - 1
			ofs = (row + #FirstVisibleLine)  * #ScreenWidth + 52
			For col =  0 To #VisibleScreenWidth - 1
				Plot(col, row, IO\Frame[ofs])
				ofs + 1
			Next
		Next
		StopDrawing()
 		FlipBuffers()
	EndIf
	
	FillMemory(@IO\Frame, SizeOf(IO\Frame), 0, #PB_Long)
	
	If C64\vSyncEnabled
		IO_VSync()
	EndIf
	
	IO_ProcessEvents()
EndProcedure

Procedure.a IO_Emulate()
	ProcedureReturn IO\retval
EndProcedure
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 358
; FirstLine = 339
; Folding = ----
; EnableXP