﻿#SDL_INIT_TIMER						= $00000001
#SDL_INIT_AUDIO						= $00000010
#SDL_INIT_VIDEO						= $00000020
#SDL_INIT_CDROM						= $00000100
#SDL_INIT_JOYSTICK					= $00000200
#SDL_INIT_NOPARACHUTE				= $00100000	;< Don't catch fatal signals
#SDL_INIT_EVENTTHREAD				= $01000000	;< Not supported on all OS's
#SDL_INIT_EVERYTHING				= $0000FFFF

#SDL_AUDIO_MASK_BITSIZE				= $FF
#SDL_AUDIO_MASK_DATATYPE			= 1 << 8
#SDL_AUDIO_MASK_ENDIAN				= 1 << 12
#SDL_AUDIO_MASK_SIGNED				= 1 << 15

#AUDIO_U8							= $0008
#AUDIO_S8							= $8008
#AUDIO_U16LSB						= $0010
#AUDIO_S16LSB						= $8010
#AUDIO_U16MSB						= $1010
#AUDIO_S16MSB						= $9010
#AUDIO_U16							= #AUDIO_U16LSB
#AUDIO_S16							= #AUDIO_S16LSB
#AUDIO_S32LSB						= $8020
#AUDIO_S32MSB						= $9020
#AUDIO_S32							= #AUDIO_S32LSB
#AUDIO_F32LSB						= $8120
#AUDIO_F32MSB						= $9120
#AUDIO_F32							= #AUDIO_F32LSB

#SDL_AUDIO_ALLOW_FREQUENCY_CHANGE	= $00000001
#SDL_AUDIO_ALLOW_FORMAT_CHANGE		= $00000002
#SDL_AUDIO_ALLOW_CHANNELS_CHANGE	= $00000004
#SDL_AUDIO_ALLOW_ANY_CHANGE  		= (#SDL_AUDIO_ALLOW_FREQUENCY_CHANGE|#SDL_AUDIO_ALLOW_FORMAT_CHANGE|#SDL_AUDIO_ALLOW_CHANNELS_CHANGE)

Structure SDL_AudioSpec
	freq.l
	format.u
	channels.a
	silence.a
	samples.l
	size.l
	*callback
	*userdata
EndStructure

Import "SDL2.lib"	
	SDL_Init.l(flags.l)
	SDL_GetNumAudioDevices.l(iscapture.l)
	SDL_GetAudioDeviceName(index.l, iscapture.l)
	SDL_OpenAudio.l(*desired.SDL_AudioSpec, *obtained.SDL_AudioSpec)
	SDL_OpenAudioDevice(*device, iscapture.l, *desired.SDL_AudioSpec, *obtained.SDL_AudioSpec, allowed_changes)
	SDL_CloseAudio()
	SDL_PauseAudio(pause_on.l)
	SDL_GetError()
	SDL_GetAudioDriver(index.l)
	SDL_GetAudioStatus()
	SDL_Delay(ms.l)
	
	SDL_NewAudioStream(src_format.u, src_channels.a, src_rate.l, dst_format.u, dst_channels.a, dst_rate.l)
	SDL_AudioStreamPut(*stream, *buffer, len.l)
	SDL_AudioStreamAvailable(*stream)
	SDL_AudioStreamFlush(*stream)
	SDL_AudioStreamClear(*stream)
	SDL_FreeAudioStream(*stream)
	
	SDL_QueueAudio.l(deviceID.l, *data, len.l)
	SDL_ClearQueuedAudio(deviceID.l)
	SDL_GetQueuedAudioSize(deviceID.l)
EndImport

Procedure.s SDL_GetErrorMessage()
	ProcedureReturn PeekS(SDL_GetError(), -1, #PB_UTF8)
EndProcedure
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 72
; FirstLine = 18
; Folding = -
; EnableXP