﻿XIncludeFile("PB64__DECLARE.pbi")

Procedure SID_Init()
	Protected n
	
	SID_Quit()
	
	ClearStructure(@SID, S_SID)
	InitializeStructure(@SID, S_SID)
	
	SID_createCombinedWF(SID_TriSaw_8580(),			0.8, 2.4, 0.64)
	SID_createCombinedWF(SID_PulseSaw_8580(),		1.4, 1.9, 0.68)
	SID_createCombinedWF(SID_PulseTriSaw_8580(),	0.8, 2.5, 0.64)

	SID\clock_ratio				= #C64_PAL_CPUCLK / #SID_SAMPLERATE
	If SID\clock_ratio = 0
		SID\clock_ratio = 1
	EndIf
	
	SID\sampleratio				= #C64_PAL_CPUCLK / #SID_SAMPLERATE
	If SID\sampleratio = 0
		SID\sampleratio = 1
	EndIf
	
	For n = 0 To 2
		SID\ADSRstate[n]		= #SID_HOLDZERO_BITMASK
		SID\noise_LFSR[n]		= $7FFFF8
	Next
		
	Restore FILTSW
	For n = 0 To 8
		Read.a SID_FILTSW(n)
	Next
	
	Restore ADSRperiods
	For n = 0 To 15
		Read.i SID_ADSRperiods(n)
; 		SID_ADSRperiods(n) * 16
	Next
	
	Restore ADSR_exptable
	For n = 0 To 255
		Read.a SID_ADSRexptable(n)
	Next
	
	If SDL_Init(#SDL_INIT_AUDIO) < 0
		MessageRequester("SDL_Init", SDL_GetErrorMessage()) : End
	EndIf
		
	Protected soundspec.SDL_AudioSpec
	soundspec\freq		= #SID_SAMPLERATE
	soundspec\channels	= 1
	soundspec\format	= #AUDIO_S16
	soundspec\samples	= #SID_BUFFERSIZE
	soundspec\userdata	= #Null
	soundspec\callback	= #Null
	
	SDL_OpenAudio(@soundspec, 0)
	SID\SDL_Device = 1
; 	SID\SDL_Device = SDL_OpenAudioDevice(SDL_GetAudioDeviceName(1, 0), 0, @soundspec, 0, 0)
	If SID\SDL_Device < 0
		MessageRequester("SDL_OpenAudioDevice", SDL_GetErrorMessage()) : End
	EndIf
		
	SDL_PauseAudio(0)
	
	DataSection
		FILTSW:
		Data.a 1,2,4,1,2,4,1,2,4
		ADSRperiods:
		Data.i 9, 32, 63, 95, 149, 220, 267, 313, 392, 977, 1954, 3126, 3907, 11720, 19532, 31251
		ADSR_exptable:
		Data.a 1, 30, 30, 30, 30, 30, 30, 16, 16, 16, 16, 16, 16, 16, 16, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 4, 4, 4, 4, 4
		Data.a 	 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1
		Data.a 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
		Data.a  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
		Data.a 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
	EndDataSection
EndProcedure

Procedure SID_Quit()
	SDL_PauseAudio(1)
	SDL_CloseAudio()
EndProcedure

Procedure SID_createCombinedWF(Array wfarray.i(1), bitmul.d, bitstrength.d, treshold.d)
	Protected i,j,k, ik
	Protected bitlevel.d
	
	For i = 0 To 4095
		wfarray(i) = 0
		For j = 0 To 11
			bitlevel = 0
			For k = 0 To 11
				ik = (i >> k) & 1
				bitlevel + (bitmul / Pow(bitstrength, Abs(k - j)) ) * (ik - 0.5)
			Next
			If (bitlevel >= treshold)
				wfarray(i) + Pow(2, j)
			EndIf
		Next
		wfarray(i) * 12
	Next
EndProcedure

Procedure.a SID_ReadRegister(r.a)
	r % 32

	Protected retval.a
	
	Select r
		Case $19
			; POT X
			retval.a = SID\reg[r]
		Case $1A
			; POT Y
			retval.a = SID\reg[r]
		Case $1B
			; OSC3/RND
			retval.a = SID\reg[r]
		Case $1C
			; ENV3
			retval.a = SID\reg[r]
		Default
			retval = SID\busValue
	EndSelect

	ProcedureReturn retval
EndProcedure

Procedure SID_WriteRegister(r.a, v.a)
	r % 32
	SID\busValue = v
	
	SID\reg[r] = v
EndProcedure

Procedure.w SID_OneSample(*sid.S_SID)
	; SID-Emulation based on 'cSID' by Hermit (Mihaly Horvath)
	
	Static.a ctrl, SR, prevgate, wf, test, reg17
	Static.l period, accuadd, pw, wfout
	Static.l MSB
	Static.l nonfilt, filtin
	Static.l output, filtout, ftmp
	Protected.l n, channel, tmp, stp
	
	filtin	= 0
	nonfilt	= 0
	
	For n = 0 To 2
		channel = n * 7
		ctrl = *sid\reg[channel + $4]
		
		; ADSR envelope generator
		sr = *sid\reg[channel + $6]
		prevgate = *sid\ADSRstate[n] & #SID_GATE_BITMASK
		If prevgate <> (ctrl & #SID_GATE_BITMASK)
			If prevgate
				*sid\ADSRstate[n] & ~(#SID_GATE_BITMASK | #SID_ATTACK_BITMASK | #SID_DECAYSUSTAIN_BITMASK)
			Else
				*sid\ADSRstate[n] = (#SID_GATE_BITMASK | #SID_ATTACK_BITMASK | #SID_DECAYSUSTAIN_BITMASK)
			EndIf
		EndIf
		If *sid\ADSRstate[n] & #SID_ATTACK_BITMASK
			period = SID_ADSRperiods(*sid\reg[channel + $5] >> 4)
		ElseIf *sid\ADSRstate[n] & #SID_DECAYSUSTAIN_BITMASK
			period = SID_ADSRperiods(*sid\reg[channel + $5] & $F)
		Else
			period = SID_ADSRperiods(sr & $F)
		EndIf

		*sid\ratecnt[n] = (*sid\ratecnt[n] + 1) & $7FFF
		If (*sid\ratecnt[n] = period)
			*sid\ratecnt[n] = 0
			*sid\expcnt[n] + 1
			If (*sid\ADSRstate[n] & #SID_ATTACK_BITMASK) Or (*sid\expcnt[n] = SID_ADSRexptable(*sid\envcnt[n]))
				*sid\expcnt[n] = 0
				If (*sid\ADSRstate[n] & #SID_HOLDZERO_BITMASK) = 0
					If *sid\ADSRstate[n] & #SID_ATTACK_BITMASK
						*sid\envcnt[n] + 1
						If *sid\envcnt[n] = $FF
							*sid\ADSRstate[n] & ~#SID_ATTACK_BITMASK
						EndIf
					ElseIf ((*sid\ADSRstate[n] & #SID_DECAYSUSTAIN_BITMASK) = 0) Or (*sid\envcnt[n] <> ((sr >> 4) + (sr & $F0)) )
						*sid\envcnt[n] - 1
						If *sid\envcnt[n] = 0
							*sid\ADSRstate[n] | #SID_HOLDZERO_BITMASK
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
		
		; WAVE generation codes (phase accumulator and waveform-selector)
		test = ctrl & #SID_TEST_BITMASK
		wf = ctrl & $F0
		accuadd = (*sid\reg[channel + $0] | (*sid\reg[channel + $1] << 8)); * 16
		
		If (test Or ((ctrl & #SID_SYNC_BITMASK) And *sid\sourceMSBrise))
			*sid\phaseaccu[n] = 0
		Else
			*sid\phaseaccu[n] = (*sid\phaseaccu[n] + accuadd) & $FFFFFF
		EndIf
		MSB = *sid\phaseaccu[n] & $800000
		*sid\sourceMSBrise = Bool(MSB > (*sid\prevaccu[n] & $800000))
		If (wf & #SID_NOISE_BITMASK)
			tmp = *sid\noise_LFSR[n]
			If (*sid\phaseaccu[n] & $100000) <> (*sid\prevaccu[n] & $100000)
				stp = (tmp & $400000) ! ((tmp & $20000) << 5)
				If stp
					tmp = ((tmp << 1) + 1) & $7FFFFF
				Else
					tmp = ((tmp << 1) + test) & $7FFFFF
				EndIf
				*sid\noise_LFSR[n] = tmp
			EndIf
			If (wf & $70)
				wfout = 0
			Else
				wfout = ((tmp & $100000) >> 5) + ((tmp & $40000) >> 4) + ((tmp & $4000) >> 1) + ((tmp & $800) << 1) + ((tmp & $200) << 2) + ((tmp & $20) << 5) + ((tmp & $04) << 7) + ((tmp & $01) << 8)
			EndIf
		ElseIf (wf & #SID_PULSE_BITMASK)
			pw = (*sid\reg[channel + $02] | (*sid\reg[channel + $03] & $F) << 8) << 4
			
			tmp = *sid\phaseaccu[n] >> 8
			If (wf = #SID_PULSE_BITMASK)
				If test Or (tmp >= pw)
					wfout = $FFFF
				Else
					wfout=0
				EndIf
			Else ; combined pulse
				If (tmp >= pw) Or test
					wfout = $FFFF
				Else
					wfout = 0
				EndIf
				If wf & #SID_TRI_BITMASK
					If wf & #SID_SAW_BITMASK
						If wfout
							wfout = SID_PulseTriSaw_8580(tmp >> 4)
						Else
							wfout = 0
						EndIf
					Else ; pulse+saw+triangle (waveform nearly identical To tri+saw)
						If ctrl & #SID_RING_BITMASK
							tmp = *sid\phaseaccu[n] ! *sid\sourceMSB
						Else
							tmp = *sid\phaseaccu[n]
						EndIf
						If wfout
							If tmp & $800000
								wfout = SID_PulseSaw_8580((tmp ! $FFFFFF) >> 11)
							Else
								wfout = SID_PulseSaw_8580(tmp >> 11)
							EndIf
						EndIf
					EndIf
					; pulse+triangle
				ElseIf (wf & #SID_SAW_BITMASK)
					If wfout
						wfout = SID_PulseSaw_8580(tmp >> 4)
					EndIf
				EndIf
			EndIf
			; pulse+saw
		ElseIf (wf & #SID_SAW_BITMASK)
			wfout =*sid\phaseaccu[n] >> 8 ; saw
			If (wf & #SID_TRI_BITMASK)
				wfout = SID_TriSaw_8580(wfout >> 4)
			EndIf
		ElseIf (wf & #SID_TRI_BITMASK)
			If ctrl & #SID_RING_BITMASK
				tmp = *sid\phaseaccu[n] ! *sid\sourceMSB
			Else
				tmp = *sid\phaseaccu[n]
			EndIf
			If tmp & $800000
				wfout = (tmp ! $FFFFFF) >> 7
			Else
				wfout = tmp >> 7
			EndIf
		EndIf
		
		If wf 
			*sid\prevwfout[n] = wfout
		Else
			wfout = *sid\prevwfout[n]
		EndIf ; emulate waveform 00 floating wave-DAC
		
		*sid\prevaccu[n] = *sid\phaseaccu[n]
		*sid\sourceMSB = MSB
		If (*sid\reg[$17] & SID_FILTSW(n))
			filtin + ((wfout - $8000) * *sid\envcnt[n]) >> 8
		ElseIf (SID_FILTSW(n) <> 4) Or ((*sid\reg[$18] & #SID_OFF3_BITMASK) = 0)
			nonfilt + ((wfout - $8000) * *sid\envcnt[n]) >> 8
		EndIf
	Next
	
	; update readable SID1-registers (some SID tunes might use 3rd n ENV3/OSC3 value As control)
	; OSC3, ENV3 (some players rely on it) 
	*sid\reg[$1B] = wfout >> 8
	*sid\reg[$1C] = *sid\envcnt[2]
	
	; FILTER
	*sid\filterctrl_prescaler - 1
	If *sid\filterctrl_prescaler = 0
		; calculate cutoff and resonance curves only at samplerate is still adequate and reduces CPU stress of frequent float calculations
		*sid\filterctrl_prescaler = *sid\clock_ratio
		
		tmp = 2 + (*sid\reg[$16] << 3) + (*sid\reg[$15] & 7)
		*sid\cutoff = Int( 1 - Exp(tmp * SID_cutoff_ratio_8580) ) << 16

		reg17 = *sid\reg[$17] >> 4
		*sid\resonance = Int( Pow(2, ((4 - reg17) / 8.0)) ) << 8
	EndIf
	filtout = 0; the filter-calculation itself can't be prescaled because sound-quality would suffer of no 'oversampling'
	ftmp = filtin + *sid\prevbandpass * *sid\resonance / $100 + *sid\prevlowpass
	If *sid\reg[$18] & #SID_HIGHPASS_BITMASK
		filtout - ftmp
	EndIf
	ftmp = *sid\prevbandpass - (ftmp * *sid\cutoff) >> 16
	*sid\prevbandpass = ftmp
	If (*sid\reg[$18] & #SID_BANDPASS_BITMASK)
		filtout - ftmp
	EndIf
	ftmp = *sid\prevlowpass + (ftmp * *sid\cutoff) >> 16
	*sid\prevlowpass = ftmp
	If (*sid\reg[$18] & #SID_LOWPASS_BITMASK)
		filtout + ftmp
	EndIf
	
	output = (nonfilt + filtout) * (*sid\reg[$18] & $F) / #SID_OUTPUT_SCALEDOWN
	If output >= 32767
		ProcedureReturn 32767
	ElseIf output <= -32767
		ProcedureReturn -32767
	EndIf
	
	ProcedureReturn output
EndProcedure

Procedure SID_Emulate()
	Static output, sample, cycle
	
	If C64\SoundEnabled And C64\vSyncEnabled
 		output = SID_OneSample(SID)
		cycle = (cycle + 1) % (SID\clock_ratio)
		If cycle = 0
			SID\buffer[sample] = output
			If sample < #SID_BUFFERSIZE - 1
				sample + 1
			Else
				If SDL_GetQueuedAudioSize(SID\SDL_Device) < #SID_BUFFERSIZE * 8
					If SDL_QueueAudio(SID\SDL_Device, @SID\buffer, #SID_BUFFERSIZE * 2) < 0
						C64\ErrorMessage = "SID: " + SDL_GetErrorMessage()
						C64\State | #C64_State_Error
						ProcedureReturn #False
					EndIf
					sample = 0
				EndIf
			EndIf
		EndIf
	EndIf
	
	ProcedureReturn #True
EndProcedure
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 367
; FirstLine = 314
; Folding = --
; Markers = 138
; EnableXP