﻿EnableExplicit

InitKeyboard()

Global SID_Mutex = CreateMutex()


;- ***  GLOBAL   ***
;  *****************

#Debug_CPU				= 1

Global ProgramPath.s	= GetPathPart(ProgramFilename())
Global PreferenceFile.s	= ProgramPath + "PB64_settings.ini"

Enumeration
	#MainWindow
	
	#Menu_0
	
	#m_QuickLoadFirst	= 0
	#m_QuickLoadLast	= 19
	
	#m_Open
	#m_AutoRun
	#m_SaveState
	#m_LoadState
	#m_PasteClip
	#m_Quit
	
	#m_Joystickport1
	#m_Joystickport2
	#m_JoystickKeys
	#m_JoystickConfigUp
	#m_JoystickConfigDown
	#m_JoystickConfigLeft
	#m_JoystickConfigRight
	#m_JoystickConfigFire
	#m_Vsync
	#m_Sound
	#m_Reset
	
	#StatusBar
EndEnumeration

EnumerationBinary
	#C64_State_Error
	#C64_State_Quit
EndEnumeration

#C64_PAL_CPUCLK			= 985248
#C64_NTSC_CPUCLK		= 1022727

Enumeration
	#C64_Joystick_Port1
	#C64_Joystick_Port2
	#C64_KeyBrd
EndEnumeration

Enumeration
	#C64_Joystick_Up
	#C64_Joystick_Down
	#C64_Joystick_Left
	#C64_Joystick_Right
	#C64_Joystick_Fire
EndEnumeration

Structure S_C64
	Zoom.d
	
	JoystickPort.a
	JoystickKey.a[5]
	
	SoundEnabled.a
	vSyncEnabled.a
	
	State.i
	pathPrg.s
	pathState.s
	
	ErrorMessage.s
EndStructure

Global C64.S_C64
C64\Zoom								= 2
C64\vSyncEnabled						= 1
C64\SoundEnabled						= 1
C64\JoystickPort						= #C64_Joystick_Port2

Macro ISSET_BIT(v_, b_)
	Bool( ((v_) >> (b_)) & $1)
EndMacro



Declare C64_Emulate()

;  **************
;- ***  CPU   ***
;  **************

Enumeration
	#Addr_Implied
	#Addr_Immediate
	#Addr_Zeropage
	#Addr_ZeropageX
	#Addr_ZeropageY
	#Addr_Absolute
	#Addr_AbsoluteX
	#Addr_AbsoluteY
	#Addr_Indirect
	#Addr_Relative
	#Addr_IndirectX
	#Addr_IndirectY
	
	#Addr_IZeropage
	#Addr_IZeropageX
	#Addr_IZeropageY
	#Addr_IAbsolute
	#Addr_IAbsoluteX
	#Addr_IAbsoluteY
	#Addr_IIndirectX
	#Addr_IIndirectY
EndEnumeration

EnumerationBinary
	#CIA_IRQ
	#VIC_IRQ
EndEnumeration

EnumerationBinary
	#CIA_NMI
EndEnumeration

Structure S_CPU
	PC.u			; program counter
	A.a				; accumulator
	X.a				; x-register
	Y.a				; y-register
	SP.a			; stack pointer
	P.a				; status-register
	
	FLAG_C.a		; 0  carry flag
	FLAG_Z.a		; 1  zero flag
	FLAG_I.a		; 2  interrupt flag
	FLAG_D.a		; 3  decimal flag
	FLAG_B.a		; 4  break flag
; 	FLAG_1.a		; 5  unused (always 1)
	FLAG_O.a		; 6  overflow flag
	FLAG_N.a		; 7  negative flag
	
 	IRQ_State.a
 	NMI_State.a
	Cycles.i
EndStructure

Structure S_OPCODE
	name.s
	addrMode.a
	nCycles.a
	nBytes.a
	boundaryCheck.a
	isIllegal.a
	readByte.a
	*proc
	*addrProc
EndStructure

Global Dim Opcode.S_OPCODE($FF)

Global CPU.S_CPU

Declare C64_Reset()

;  **************
;- ***  VIC   ***
;  **************

#ScreenWidth				= 504
#ScreenHeight				= 312
#VisibleScreenWidth  		= 403
#VisibleScreenHeight 		= 284
#nColumns					= 40
#FirstLine					= 56
#FirstVisibleLine			= 14
#LastVisibleLine			= 298

#LineCycles					= 63
#BadLineCycles				= 23
#RefreshRate				= (1000.0 / 50.125)

#SpritePtrsOffset			= $3F8
#SpriteWidth				= 24
#SpriteHeight				= 21
#SpriteSize					= 64

#STANDARD_TEXT				= 0
#MULTICOLOR_TEXT			= 1
#STANDARD_BITMAP			= 2
#MULTICOLOR_BITMAP			= 3
#EXTENDED_BACKGROUND_COLOR	= 4

#IRQ_RASTER					= 0
#IRQ_SPR_BGR_COLLISION		= 1
#IRQ_SPR_SRP_COLLISION		= 2
#IRQ_LIGHTPEN				= 3

#Priority_Front				= 0
#Priority_Back				= 1

Structure S_VIC
	Priority.a[512]
	SprCollision.a[512]
	BgrCollision.a[512]
	
	CR1.a
	CR2.a
	MX.a[$100]
	MY.a[$100]
	MX_MSB.a
	
	ScreenRows25.a
	ScreenCols40.a
	
	VerticalScroll.a
	HorizontalScroll.a
	
	Display_Enabled.a
	
	Sprite_Enabled.a
	Sprite_Priority.a
	Sprite_Multicolor.a
	Sprite_DoubleWidth.a
	Sprite_DoubleHeight.a
	Sprite_Sprite_Collision.a
	Sprite_Backgr_Collision.a
	Sprite_SharedColors.a[$FF]
	Sprite_Colors.a[$FF]
	
	Border_Color.a
	Backgr_Color.a[$FF]
	
	NextRasterLine.i
	CurrentRasterLine.i
	
	Sprite_Sprite_Mask.a
	Sprite_Backgr_Mask.a
	
	IRQ_RasterLine.u
	IRQ_Flag.a
	IRQ_Mask.a
	IRQ_ACKNOWLEDGE.a
	
	Mem_Base.u
	Mem_Screen.u
	Mem_Char.u
	Mem_Bitmap.u
	Mem_VIC_Base.a
	
	GraphicMode.a
	
	Badline_Enabled.a
	Badline_status.a
	Display_status.a
	REG11_Written.a
	
	DrawLine.a
	Cycle.a
	
 	reg11Write.a
EndStructure

Declare.a VIC_ReadRegister(r.a)
Declare VIC_WriteRegister(r.a, v.a)

Global VIC.S_VIC


;  **************
;- *** MEMORY ***
;  **************

#AddressStack			= $0100
#AddressMemoryConfig	= $0001
#AddressNMI				= $FFFA
#AddressColdReset		= $FFFC
#AddressIRQ				= $FFFE

#AddressBasicArea		= $0801
#AddressBasicText		= $002B
#AddressBasicVars		= $002D 
#AddressBasicArray		= $002F
#AddressBasicArrayEnd	= $0031
    
Enumeration	
	#kRAM
	#kIO
	#kBas
	#kKrn
	#kChr	
	#kcLo
	#kcHi
	#kNo
EndEnumeration

Structure S_MEMORY
	RAM.a[$10000]
	ColorRAM.a[$1000]
	KernalROM.a[$2000]
	BasicROM.a[$2000]
	CharROM.a[$1000]
	ExtROM.a[$4001]
	Banks.a[8]
	BankLayout.a
EndStructure

Global MEMORY.S_MEMORY

Declare MEMORY_SetupBanks(v.a)
Declare.a MEMORY_Peek(ofs.u)
Declare MEMORY_Poke(ofs.u, v.a)
Declare.u MEMORY_ReadW(ofs.u)
Declare.a MEMORY_VIC_ReadB(ofs.u)
Declare MEMORY_VIC_WriteB(ofs.u, v.a)
Declare MEMORY_WriteByteNoIo(ofs.u, v.a)
Declare MEMORY_WriteWordNoIo(ofs.u, v.u)

;  **************
;- ***   IO   ***
;  **************

EnumerationBinary
	#IO_JoystickMask_Up
	#IO_JoystickMask_Down
	#IO_JoystickMask_Left
	#IO_JoystickMask_Right
	#IO_JoystickMask_Fire
EndEnumeration

Structure S_IO
	Frame.l[#ScreenWidth * #ScreenHeight]
	
	Color_Palette.i[$FF + 1]
	
;	IEC_Wire.a
	InputMode.a
	Joystick.a[2]
	
	Keyboard_Matrix.a[$FF + 1]
	Keyboard_col.a
	Keyboard_row.a
	
	Array KeyDown.a(255)
	Map keymap.u()
	Map AsciiToKeymatrix.u()
	Map KeymatrixToAscii.u()
	List KeyboardBuffer.l()	
	next_key_event_at.i
	lastFrameTime.i
	kWait.i
	
	retval.a
EndStructure

Global IO.S_IO

Macro IO_DrawPixel(x_, y_, color_)
	IO\Frame[(y_) * #ScreenWidth  + (x_)] = IO\Color_Palette[(color_)]
EndMacro
Declare IO_DrawLine(x, y, n, color)
Declare IO_RefreshScreen()
Declare IO_VSync()

;  *******************
		;- ***     CIA     ***
;  *******************

Enumeration
	#kModeRestart
	#kModeOneTime
EndEnumeration

Enumeration
	#kModeSystemFrq
	#kModeCNT
	#kModeTimerA
	#kModeTimerACNT
EndEnumeration

Structure S_CIA_TIMER
	latch.w
	counter.w
	enabled.a
	irq_enabled.a
	irq_triggered.a
	input_mode.a
	run_mode.a
EndStructure

Structure S_CIA
	RAM.a[$10]
	
	timer_a.S_CIA_TIMER
	timer_b.S_CIA_TIMER
	
	pra.a
	prb.a
	ddra.a
	ddrb.a
EndStructure

Global CIA1.S_CIA
Global CIA2.S_CIA
Global *CIA1.S_CIA = @CIA1
Global *CIA2.S_CIA = @CIA2

Declare CIA_Init(*cia.S_CIA)
Declare.a CIA_ReadRegister(*cia.S_CIA, r.a)
Declare CIA_WriteRegister(*cia.S_CIA, r.a, v.a)

;  *******************
;- ***     SID     ***
;  *******************

#SID_SAMPLERATE				= 22500
#SID_BUFFERSIZE				= 512;2048

#SID_CHANNEL_AMOUNT			= 3
#SID_OUTPUT_SCALEDOWN		= (#SID_CHANNEL_AMOUNT * 16.0 + 26)

#SID_GATE_BITMASK			= $01
#SID_SYNC_BITMASK			= $02
#SID_RING_BITMASK			= $04
#SID_TEST_BITMASK			= $08
#SID_TRI_BITMASK			= $10
#SID_SAW_BITMASK			= $20
#SID_PULSE_BITMASK			= $40
#SID_NOISE_BITMASK			= $80
#SID_HOLDZERO_BITMASK		= $10
#SID_DECAYSUSTAIN_BITMASK	= $40
#SID_ATTACK_BITMASK			= $80
#SID_LOWPASS_BITMASK		= $10
#SID_BANDPASS_BITMASK		= $20
#SID_HIGHPASS_BITMASK		= $40
#SID_OFF3_BITMASK			= $80

Structure S_SID
	reg.a[32]
	
	buffer.w[#SID_BUFFERSIZE * 2]

	ofs.i
	output.w
	
	update.a
	busValue.a
	
	SDL_Device.l
	
	sampleRatio.l
	clock_ratio.l
	ratecnt.u[3]
	prevwfout.u[3]
	phaseaccu.l[3]
	prevaccu.l[3]
	sourceMSB.l[3]
	noise_LFSR.l[3]
	prevlowpass.l[3]
	prevbandpass.l[3]
	ADSRstate.a[3]
	expcnt.a[3]
	envcnt.a[3]
	sourceMSBrise.a
	filterctrl_prescaler.a
	cutoff.l
	resonance.l
EndStructure

Global SID.S_SID


Global Dim SID_TriSaw_8580.i(4096)
Global Dim SID_PulseSaw_8580.i(4096)
Global Dim SID_PulseTriSaw_8580.i(4096)

Global Dim SID_FILTSW.l(8)
Global Dim SID_ADSRperiods.l(15)
Global Dim SID_ADSRexptable.a(255)

Global SID_cutoff_ratio_8580.d	= -2 * #PI * (12500.0 / 2048) / #C64_PAL_CPUCLK
Global SID_cutoff_ratio_6581.d	= -2 * #PI * (20000.0 / 2048) / #C64_PAL_CPUCLK
Global SID_cutoff_bias_6581.d	= 1 - Exp( -2 * 3.14 * 220 / #C64_PAL_CPUCLK )	 ; //around 220Hz below treshold
 
Declare.a SID_ReadRegister(r.a)
Declare SID_WriteRegister(r.a, v.a)
Declare.w SID_OneSample(*sid.S_SID)
Declare SID_createCombinedWF(Array wfarray.i(1), bitmul.d, bitstrength.d, treshold.d)
Declare SID_Quit()

;  *******************
;- ***    VC1541   ***
;  *******************

Structure S_VC1541
	buffer.a[$30000]
	Array D64Offset.l(41)
	path.s
EndStructure

Declare.s PETSCII2ASCII(petsciiVal.a)
	
;  *******************
;- ***    DEBUG    ***
;  *******************

Structure S_DEBUG
	Opcode.s
	Param1.s
	Param2.s
	AddrMode.s
EndStructure

Global DBG.S_DEBUG
; IDE Options = PureBasic 5.72 (Windows - x64)
; CursorPosition = 389
; FirstLine = 374
; Folding = -
; EnableXP